clear all
close all

Fs = 1000;
signal = 1;
load_signal;

fast_processing = 0;  %% if 1, computation time is much longer, if 0, please ignore results for ST reconstruction method 1


s0 = s;
s0 = s0 - mean(s0);  %% zero centering


SNR_range = 25; %45;
M_range     = [300 500 1000 2000]; %[300 400 500 1000 2000];   %100 200
gamma_range = [1e-1 1e-2 1e-3 1e-4];

gamma_K_default  = 10^(-3);
M_default   = 500;
w0T_default = 2 * 2* pi; %7 * 2* pi;

chemin = sprintf('figs_TSP/%d/', signal);
if ~exist(chemin, 'dir')
  mkdir(chemin);
end

fp = fopen(sprintf('%s/results_tab.txt', chemin), 'w+t');

methods ={'S-transform reconstruction (Method 1)',...
          'S-transform reconstruction (Method 2)'};
      
nb_methods = length(methods);


M_tab_results       = zeros(nb_methods, length(M_range));
gamma_tab_results   = zeros(nb_methods, length(gamma_range));

for idx0 = 1:length(SNR_range)
    
 noise = randn(size(s));
 
 s = sigmerge(s0, noise, SNR_range(idx0));
 s = s-mean(s);
 rsb = SNR(s0, s);
 
 
 %% M_tab_results
 for idx = 1:length(M_range)
   w0T = w0T_default; %w0T_range(idx);   
   f0T = w0T/(2*pi);
   M = M_range(idx);
   M2 = round(M/2)+1;
   gamma_K = gamma_K_default;
   %% compute the classical S-transform + synchrosqueezed versions (first- and second-order)
   
   %% zeropadding
   if fast_processing == 0
    z_pad  = round(w0T * M * sqrt(2*log(1/gamma_K)) / (pi));
   else
    z_pad = 0; 
   end
   
    x = [zeros(z_pad,1) ; s ; zeros(z_pad, 1)];
    i_s = z_pad+1:(length(x)-z_pad);

    s_hat = zeros(nb_methods+1, length(x));
   
    [tfr] = tfrst(x, M, w0T, gamma_K_default);
    
    %% reconstruction method 1
    s_hat(1,:) = 2*real(rectfrst(tfr(1:M2,:), m_axis(M,1:M2), M));
    %s_hat(1,:) = s_hat(1,i_s);
    %[s_hat] = rectfrst(tfr);
    fprintf('S-transform reconstruction (1st formula), RQF=%0.02f, f_0 T=%0.02f, gammaK=%.5f, M=%d\n', RQF(s,s_hat(1,i_s)'), f0T,gamma_K,M);

    %% reconstruction method 2
    s_hat(2,:) = 2*real(rectfrst2(tfr(1:M2,:), w0T, m_axis(M,1:M2), M));
    %s_hat(2,:) = s_hat(2,i_s);
    fprintf('S-transform reconstruction (2nd formula), RQF=%0.02f, f_0 T=%0.02f, gammaK=%.5f, M=%d\n', RQF(s,s_hat(2,i_s)'), f0T,gamma_K,M);
    
    
   fprintf(1, '\n');
   for i = 1:nb_methods
    M_tab_results(i, idx) = RQF(s.', s_hat(i, i_s));
    tmp = sprintf('+ %s\t, SNR=%d, w0T=%.2f, f0T=%.2f, gammaK=%.5f, M=%d\tRQF=%.2f \n', methods{i}, rsb,  w0T, f0T, gamma_K, M, M_tab_results(i, idx));
    %fprintf(1,  tmp);
    fprintf(fp, tmp);
   end
 end
 
 %% M_tab_results
 for idx = 1:length(gamma_range)
   w0T = w0T_default; %w0T_range(idx);   
   f0T = w0T/(2*pi);
   M = M_default;
   M2 = round(M/2)+1;
   gamma_K = gamma_range(idx);
   %% compute the classical S-transform + synchrosqueezed versions (first- and second-order)
   
   %% zeropadding
   if fast_processing == 0
    z_pad  = round(w0T * M * sqrt(2*log(1/gamma_K)) / (pi));
   else
    z_pad = 0; 
   end
   
    x = [zeros(z_pad,1) ; s ; zeros(z_pad, 1)];
    i_s = z_pad+1:(length(x)-z_pad);

    s_hat = zeros(nb_methods+1, length(x));
   
    [tfr] = tfrst(x, M, w0T, gamma_K_default);
%     
%     [tfr, stfr, ~, ~, lost1] = tfrtsst(x, M, w0T, gamma_K);
%     [~, stfr2, ~, lost2] = tfrhsst(x, M, w0T, gamma_K);

%    %[tfr0p]      =  tfrst(s0p, M, w0T, gamma_K);
%    [tfr, stfr]  =  tfrsst(s, M, w0T, gamma_K);
%    [~,   vstfr] = tfrvsst(s, M, w0T, gamma_K);


    %% reconstruction method 1
    s_hat(1,:) = 2*real(rectfrst(tfr(1:M2,:), m_axis(M,1:M2), M));
    %s_hat(1,:) = s_hat(1,i_s);
    %[s_hat] = rectfrst(tfr);
    fprintf('S-transform reconstruction (1st formula), RQF=%0.02f, f_0 T=%0.02f, gammaK=%.5f, M=%d\n', RQF(s,s_hat(1,i_s)'), f0T,gamma_K,M);

    %% reconstruction method 2
    s_hat(2,:) = 2*real(rectfrst2(tfr(1:M2,:), w0T, m_axis(M,1:M2), M));
    %s_hat(2,:) = s_hat2(2,i_s);
    fprintf('S-transform reconstruction (2nd formula), RQF=%0.02f, f_0 T=%0.02f, gammaK=%.5f, M=%d\n', RQF(s,s_hat(2,i_s)'), f0T,gamma_K,M);
    
    
   fprintf(1, '\n');
   for i = 1:nb_methods
    gamma_tab_results(i, idx) = RQF(s.', s_hat(i, i_s));
    tmp = sprintf('+ %s\t, SNR=%d, w0T=%.2f, f0T=%.2f,gamma_K=%.5f, M=%d\tRQF=%.2f \n', methods{i}, rsb,  w0T, f0T, gamma_K, M, gamma_tab_results(i, idx));
    %fprintf(1,  tmp);
    fprintf(fp, tmp);
   end
 end
 
%   
%  for i = 1:length(methods)
%   tmp = sprintf('----  %s ---- \n', methods{i});
%   fprintf(1,'%s', tmp);fprintf(fp,'%s', tmp);
%   
%   tmp = sprintf(gen_tab('$f_{0}T$', w0T_range/(2*pi), w0T_tab_results(i,:), 'A'));
%   fprintf(1,'%s', tmp);fprintf(fp,'%s', tmp);
%   
%   tmp = sprintf(gen_tab('$M$',  M_range, M_tab_results(i,:), 'B'));
%   fprintf(1,'%s', tmp);fprintf(fp,'%s', tmp);
%   
% %   if i == 3 %% synchrosqueezing
% %    tmp = sprintf(gen_tab('$\\mu$',  mu_range, mu_tab_results, 'C'));
% %    fprintf(1,'%s', tmp);fprintf(fp,'%s', tmp);
% %   end
%   fprintf(1, '\n');
%   fprintf(fp, '\n');
%  end
end

fclose(fp);